// TODO:
// MAKE THE CONVERSATION ASSEMBLY ASYNCHRONOUS, ADAM

var convoDiv = document.getElementById('convoArea');
var infoDiv = document.getElementById('infoArea');
var postURL = document.getElementById('postURL');
var barfDiv = document.getElementById('barfArea');
var convo;

function conversationFromNoticePermalink(postUrl){
    // This is the main function to get things rolling. Pass me the
    // URL of any GNU social notice, and I'll hunt down the rest of
    // the conversation.
    convo = {"convosChecked" : [],
		 "nodesChecked" : [],
		 "items": []};
    if(convoDiv.querySelector("article")){
	returnItemsToTimeline();
    }
    convoDiv.innerHTML = "";
    barfDiv.innerHTML = "";
    infoDiv.style.display = "none";
    barf("CONVERSATION MANIFEST<br><br>")
    mergeConvoOfPost(postUrl,convo);
}

function mergeConvoOfPost(postUrl,conversation){
    // Pass me the permalink URL of a post, and I will retrieve it; then
    // I'll get the activity streams conversation that it's a part of on
    // its server and merge it with the conversation object you've passed
    // me.

    // *** Currently, this relies on the JSON representation of posts,
    // because the node-local conversation ID is missing from the Atom
    // representation. ***

    var postJsonUrl = postPermalinkToJsonUrl(postUrl);
    barf("Fetching post: " + postJsonUrl);
    var proxiedPostJsonUrl = proxyString + postJsonUrl;
    var fetcher = new XMLHttpRequest();
    fetcher.onload = function(postUrl,convo){
	// Regardless of the result, we DID check this node.
	var splitPostUrl = postUrl.trim().split("/");
	convo.nodesChecked.push(splitPostUrl[2]);
	if (fetcher.status === 200){
	    var postJson;
	    try{
		postJson = JSON.parse(this.responseText); 
	    }
	    catch(err){
		barf("ERROR: Response is not parseable JSON.");
	    }
	    if (postJson){ // Valid JSON; but is it what we want?
		if (postJson.error){ 
		    barf("...no go. Friendica hates us."); // See [1]
		    doNextPost(convo);
		} else { // Success! Now start grabbing the conversation.
		    barf(" ...local convo ID is " + postJson.statusnet_conversation_id + ".");
		    var asConvoUrl = splitPostUrl[0] + "//" + splitPostUrl[2] +
			"/api/statusnet/conversation/" + postJson.statusnet_conversation_id +
			".atom";	    
		    fetchConvoToMerge(asConvoUrl,convo);
		}
	    } else {
		doNextPost(convo);
	    }
	} else {
	    // If we didn't get a response we can use, just jump ahead to
	    // auditConvo and see if we can carry on.
	    barf("HTTP " + this.status + " — Okay, let's forget about that one...");
	    doNextPost(convo);
        }
    }.bind(fetcher,postUrl,conversation);
    fetcher.open('GET',proxiedPostJsonUrl,true);
    fetcher.send();
    // ---------------------------------------------------------------
    // [1] Some Friendica instances won't let us at the API without
    // authentication.  They're nice enough to give us an error in the
    // form of a JSON response though.
}
	
function postPermalinkToJsonUrl(permalink){
    // Give me a post's permalink URL and I will return to you the
    // URL of its JSON representation.
    var splitPostUrl = permalink.trim().split("/");
    var jsonUrl = splitPostUrl[0] + "//" + splitPostUrl[2] +
	"/api/statuses/show/" + splitPostUrl[splitPostUrl.length-1] + ".json";
    return jsonUrl;
}


function fetchConvoToMerge(convoUrl,convo){
    // Pass me the URL of an ActivityStreams ATOM conversation, and I will
    // retrieve it and merge it with the conversation object you've
    // passed.


    var proxiedConvoUrl = proxyString + convoUrl;
    var convoEntries = [];
    var convoPage = 1;
    var morePages = false;
    var fetcher = new XMLHttpRequest();

    // The API only gives 20 items, so we need a do...while loop to go
    // over multiple pages of conversation.  

    // TODO: DO THIS ASYNCHRONOUSLY!
    do {
	barf(`Fetching entries from ${convoUrl}, page ${convoPage}...`);
	fetcher.open('GET',proxiedConvoUrl+"?page="+convoPage,false); // SYNCHRONOUS request
	fetcher.send();
	if (fetcher.status === 200){
	    var entries = objectify(fetcher.responseXML);
	    convoEntries = mergeTl(entries,convoEntries);
	    (entries.length > 19) ? morePages=true : morePages=false;
	} else {
	    barf("ERROR: HTTP " + fetcher.status);
	    break;
	}
	convoPage++;
    } while (morePages);
    convo.convosChecked.push(convoUrl);
    mergeConvo(convoEntries,convo);
}

function mergeConvo(entries,convo){
    // Pass me the entries from one server's view of the conversation
    // and I'll merge them with the conversation object you've passed.
    
    var newItem;
    var oldItem;
    var mergeCount = 0;
    for (var ix = 0; ix < entries.length ; ix++) {
	newItem = entries[ix];
	oldItem = hasDuplicate(newItem, convo.items,"id");
	// hasDuplicate() returns true if the item is not currently
	// present in convo, or it returns the matching item from
	// convo
	if (oldItem === false){
	    convo.items.push(newItem);
	    mergeCount++;
	} else {
	    // Even if the newItem is a duplicate of one we've
	    // previously collected, it may still be useful.  On some
	    // items in some conversations, the object.inReplyTo
	    // object is missing.  If the version of the item that we
	    // already have in the conversation is missing its
	    // inReplyTo object, see if newItem has it.  If so, copy
	    // it over.
	    if (newItem.replyTo && !oldItem.replyTo){		
		oldItem.replyTo = newItem.replyTo;
	    }
	}	
    }
    barf(`Merged ${mergeCount} items.`);
    doNextPost(convo);
}

function doNextPost(convo){
    var doMeNext = auditConvo(convo);
    if (doMeNext != "none") {
	renderConvo(convo);
	mergeConvoOfPost(doMeNext,convo);
    } else {
	renderConvo(convo);
    }
}
function auditConvo(convo){
    // Do we keep looking for conversations to merge?
    for (var i = 0; i < convo.items.length; i++){
	// Go through the conversation's items, and see if the item's originating
	// Node has been checked yet.

	var itemUrl = convo.items[i].permalink;
	var node = itemUrl.split('/')[2];
	if(!nodeIsChecked(node,convo)){
	    return itemUrl;
	}
    }
    return "none";
}
function nodeIsChecked(node,convo){
    for (var i = 0; i < convo.nodesChecked.length; i++){
	if (node == convo.nodesChecked[i]){
	    return true;
	}
    }
    return false;
}
function renderConvo(convo){    
    // Sort items by date, (item.published)
    convo.items.sort(timeCompare);

    for (var i = 0; i < convo.items.length ; i++){
	// If the article is already in ÆGNUS somewhere, just move
	// it into the conversation <div>.
	if(document.getElementById(convo.items[i].id)){
	    article = document.getElementById(convo.items[i].id);
	} else {
	    article = itemToTimelineElement(convo.items[i]);
	}
	convoDiv.appendChild(article);
    }
    
    // then thread them by item.object.inReplyTo.id
    var convoItems = convoDiv.querySelectorAll("article");
    for (var i = 0; i < convo.items.length ; i++){
	var item = convo.items[i];
	if (item.replyTo){
	    var antecedentUrl = item.replyTo;
	    var itemContainer = document.getElementById(item.id);
	    if(document.querySelector('article[data-permalink="'+antecedentUrl+'"]')){
		var antecedentContainer = document.querySelector('article[data-permalink="'+antecedentUrl+'"]').querySelector(".drawer");
		antecedentContainer.appendChild(itemContainer);
	    }
	} else if (item.activityVerb == "share"){
	    var article = document.getElementById(item.id);
	    var drawer = document.getElementById(item.object.id).querySelector(".drawer");
	    if(!drawer.firstElementChild){
	    	drawer.appendChild(article);
	    } else {
	    	drawer.insertBefore(article,drawer.firstElementChild);
	    }
	}
    }
}
function timeCompare(a,b) {
    if (Date.parse(a.published) < Date.parse(b.published))
	return -1;
    else if (Date.parse(a.published) > Date.parse(b.published))
	return 1;
    else 
	return 0;
}

function hasDuplicate(item,items,attr){
    // I compare the passed attribute of an item with those of the passed
    // array's items.  Return the matching item, or 'false' if the
    // item has no duplicate.
    for (var ix = 0; ix < items.length; ix++){
	var oldItem = items[ix];
	if (item[attr] == oldItem[attr]){
	    return items[ix];
	}
    }
    return false;
}
function returnItemsToTimeline(){
    // Since we steal <article>s from the timeline when rendering a 
    // conversation, we want to put them back when we're done. 

    // TODO ??? Integrate the new conversation items back into the
    // timeline instead of deleting them?

    var items = convoDiv.querySelectorAll("article");
    var ids = [];
    var killIds = [];
    for (var ix = 0; ix < items.length; ix++){
	if(hasDuplicate(items.item(ix),tlItems,"id")){
	    // We push the items to an array, because if we move them
	    // now, items inside of other items' drawers will be moved
	    // with them, so we'll have nested articles in the timeline.
	    // And we don't want that.
	    ids.push(items.item(ix));
	}
	else{
	    killIds.push(items.item(ix));
	}
    }
    for (var ix = 0; ix < killIds.length; ix++){
	killIds[ix].parentElement.removeChild(killIds[ix]);
    }
    for (var ix = 0; ix < ids.length; ix++){
	    timelineMain.appendChild(ids[ix]);
    }
    renderTimeline();
}
function barf(text){
    barfDiv.innerHTML+=`<p class="barf">${text}</p>`;
}

    
